export async function* chunkByAsync(iterable, predicate) {
    let buffer = [];
    let index = 0;
    for await (const element of iterable) {
        buffer.push(element);
        if (await predicate(element, index)) {
            yield buffer;
            buffer = [];
        }
        index++;
    }
    if (buffer.length)
        yield buffer;
}
//# sourceMappingURL=chunk-by-async.js.map