export function* chunkBy(iterable, predicate) {
    let buffer = [];
    let index = 0;
    for (const element of iterable) {
        buffer.push(element);
        if (predicate(element, index)) {
            yield buffer;
            buffer = [];
        }
        index++;
    }
    if (buffer.length)
        yield buffer;
}
//# sourceMappingURL=chunk-by.js.map