import { go } from '@blackglory/go';
import { copyAsyncIterable } from './utils.js';
import { assert } from '@blackglory/errors';
export function dropAsync(iterable, count) {
    assert(Number.isInteger(count), 'The parameter count must be an integer');
    assert(count >= 0, 'The parameter count must be greater than or equal to 0');
    if (count === 0)
        return copyAsyncIterable(iterable);
    return go(async function* () {
        var _a;
        const iterator = iterable[Symbol.asyncIterator]();
        let done;
        try {
            let value;
            while ({ value, done } = await iterator.next(), !done) {
                if (count <= 0)
                    break;
                count--;
            }
            while (!done) {
                yield value;
                ({ value, done } = await iterator.next());
            }
        }
        finally {
            if (!done)
                await ((_a = iterator.return) === null || _a === void 0 ? void 0 : _a.call(iterator));
        }
    });
}
//# sourceMappingURL=drop-async.js.map