export function* dropUntil(iterable, predicate) {
    var _a;
    const iterator = iterable[Symbol.iterator]();
    let done;
    try {
        let index = 0;
        let value;
        while ({ value, done } = iterator.next(), !done) {
            if (predicate(value, index++))
                break;
        }
        while (!done) {
            yield value;
            ({ value, done } = iterator.next());
        }
    }
    finally {
        if (!done)
            (_a = iterator.return) === null || _a === void 0 ? void 0 : _a.call(iterator);
    }
}
//# sourceMappingURL=drop-until.js.map