import { go } from '@blackglory/go';
import { assert } from '@blackglory/errors';
import { copyIterable } from './utils.js';
export function drop(iterable, count) {
    assert(Number.isInteger(count), 'The parameter count must be an integer');
    assert(count >= 0, 'The parameter count must be greater than or equal to 0');
    if (count === 0)
        return copyIterable(iterable);
    return go(function* () {
        var _a;
        const iterator = iterable[Symbol.iterator]();
        let done;
        try {
            let value;
            while ({ value, done } = iterator.next(), !done) {
                if (count <= 0)
                    break;
                count--;
            }
            while (!done) {
                yield value;
                ({ value, done } = iterator.next());
            }
        }
        finally {
            if (!done)
                (_a = iterator.return) === null || _a === void 0 ? void 0 : _a.call(iterator);
        }
    });
}
//# sourceMappingURL=drop.js.map