import { isntChar } from 'extra-utils';
import { isIterable } from "./is-iterable.js";
export async function* flattenByAsync(iterable, predicate) {
    const level = 1;
    for await (const element of iterable) {
        if (isFiniteIterable(element) && await predicate(element, level)) {
            yield* flatten(element, predicate, level + 1);
        }
        else {
            yield element;
        }
    }
}
async function* flatten(iterable, predicate, level) {
    for (const element of iterable) {
        if (isFiniteIterable(element) && await predicate(element, level)) {
            yield* flatten(element, predicate, level + 1);
        }
        else {
            yield element;
        }
    }
}
function isFiniteIterable(val) {
    return isIterable(val) && isntChar(val);
}
//# sourceMappingURL=flatten-by-async.js.map