import { isntChar } from 'extra-utils';
import { isIterable } from "./is-iterable.js";
export function flattenBy(iterable, predicate) {
    return flatten(iterable, predicate, 1);
}
function* flatten(iterable, predicate, level) {
    for (const element of iterable) {
        if (isFiniteIterable(element) && predicate(element, level)) {
            yield* flatten(element, predicate, level + 1);
        }
        else {
            yield element;
        }
    }
}
function isFiniteIterable(val) {
    return isIterable(val) && isntChar(val);
}
//# sourceMappingURL=flatten-by.js.map