import { eachAsync } from "./each-async.js";
export async function groupByAsync(iterable, fn) {
    const map = new Map();
    await eachAsync(iterable, async (element, index) => {
        const group = await fn(element, index);
        if (!map.has(group)) {
            map.set(group, []);
        }
        map.get(group).push(element);
    });
    return map;
}
//# sourceMappingURL=group-by-async.js.map