import { each } from "./each.js";
export function groupBy(iterable, fn) {
    const map = new Map();
    each(iterable, (element, index) => {
        const group = fn(element, index);
        if (!map.has(group)) {
            map.set(group, []);
        }
        map.get(group).push(element);
    });
    return map;
}
//# sourceMappingURL=group-by.js.map