export async function lastAsync(iterable) {
    var _a;
    const iterator = iterable[Symbol.asyncIterator]();
    let done;
    try {
        let value;
        let result;
        while ({ value, done } = await iterator.next(), !done) {
            result = value;
        }
        return await result;
    }
    finally {
        if (!done)
            await ((_a = iterator.return) === null || _a === void 0 ? void 0 : _a.call(iterator));
    }
}
//# sourceMappingURL=last-async.js.map