export async function* splitByAsync(iterable, predicate) {
    let buffer = [];
    let index = 0;
    for await (const element of iterable) {
        if (await predicate(element, index)) {
            yield buffer;
            buffer = [];
        }
        else {
            buffer.push(element);
        }
        index++;
    }
    yield buffer;
}
//# sourceMappingURL=split-by-async.js.map