export function* splitBy(iterable, predicate) {
    let buffer = [];
    let index = 0;
    for (const element of iterable) {
        if (predicate(element, index)) {
            yield buffer;
            buffer = [];
        }
        else {
            buffer.push(element);
        }
        index++;
    }
    yield buffer;
}
//# sourceMappingURL=split-by.js.map