import { go } from '@blackglory/go';
import { assert } from '@blackglory/errors';
export function takeRightAsync(iterable, count) {
    assert(Number.isInteger(count), 'The parameter count must be an integer');
    assert(count >= 0, 'The parameter count must be greater than or equal to 0');
    return go(async function* () {
        var _a;
        const iterator = iterable[Symbol.asyncIterator]();
        let done;
        try {
            const buffer = [];
            let value;
            while ({ value, done } = await iterator.next(), !done) {
                buffer.push(await value);
                if (buffer.length > count)
                    buffer.shift();
            }
            yield* buffer;
        }
        finally {
            if (!done)
                await ((_a = iterator.return) === null || _a === void 0 ? void 0 : _a.call(iterator));
        }
    });
}
//# sourceMappingURL=take-right-async.js.map