import { go } from '@blackglory/go';
import { assert } from '@blackglory/errors';
export function takeRight(iterable, count) {
    assert(Number.isInteger(count), 'The parameter count must be an integer');
    assert(count >= 0, 'The parameter count must be greater than or equal to 0');
    return go(function* () {
        var _a;
        const iterator = iterable[Symbol.iterator]();
        let done;
        try {
            const buffer = [];
            let value;
            while ({ value, done } = iterator.next(), !done) {
                buffer.push(value);
                if (buffer.length > count)
                    buffer.shift();
            }
            yield* buffer;
        }
        finally {
            if (!done)
                (_a = iterator.return) === null || _a === void 0 ? void 0 : _a.call(iterator);
        }
    });
}
//# sourceMappingURL=take-right.js.map