import { assert } from '@blackglory/errors';
import { findInsertionIndex } from './utils.js';
export async function topAsync(iterable, num, compare) {
    assert(Number.isInteger(num), 'The parameter num must be an integer');
    assert(num > 0, 'The parameter num must be greater than 0');
    const result = [];
    for await (const element of iterable) {
        if (result.length > 0) {
            const insertionIndex = findInsertionIndex(result, element, compare);
            const maxIndex = Math.min(result.length, num - 1);
            if (insertionIndex <= maxIndex) {
                for (let i = maxIndex; i > insertionIndex; i--) {
                    result[i] = result[i - 1];
                }
                result[insertionIndex] = element;
            }
        }
        else {
            result.push(element);
        }
    }
    return result;
}
//# sourceMappingURL=top-async.js.map