export async function* uniqByAsync(iterable, fn) {
    const bucket = new Set();
    let index = 0;
    for await (const element of iterable) {
        const result = await fn(element, index);
        if (!bucket.has(result)) {
            yield element;
            bucket.add(result);
        }
        index++;
    }
}
//# sourceMappingURL=uniq-by-async.js.map