export function* uniqBy(iterable, fn) {
    const bucket = new Set();
    let index = 0;
    for (const element of iterable) {
        const result = fn(element, index);
        if (!bucket.has(result)) {
            yield element;
            bucket.add(result);
        }
        index++;
    }
}
//# sourceMappingURL=uniq-by.js.map