export async function* copyAsyncIterable(iterable) {
    for await (const element of iterable) {
        yield element;
    }
}
export function* copyIterable(iterable) {
    for (const element of iterable) {
        yield element;
    }
}
export function findInsertionIndex(sortedArray, insertionElement, compare) {
    if (sortedArray.length === 0) {
        return 0;
    }
    else {
        let startIndex = 0;
        let endIndex = sortedArray.length - 1;
        while (true) {
            const intermediateIndex = getIntermediateIndex(startIndex, endIndex);
            const result = compare(insertionElement, sortedArray[intermediateIndex]);
            if (result > 0) {
                startIndex = intermediateIndex + 1;
                if (startIndex > endIndex) {
                    return startIndex;
                }
            }
            else if (result < 0) {
                endIndex = intermediateIndex;
                if (endIndex === startIndex) {
                    return endIndex;
                }
            }
            else {
                for (let i = intermediateIndex; i < sortedArray.length; i++) {
                    if (compare(insertionElement, sortedArray[intermediateIndex]) !== 0) {
                        return i;
                    }
                }
                return sortedArray.length;
            }
        }
    }
}
export function getIntermediateIndex(startIndex, endIndex) {
    return startIndex + Math.floor((endIndex - startIndex) / 2);
}
//# sourceMappingURL=utils.js.map