export function zip(iterable, ...otherIterables) {
    return _zip(iterable, ...otherIterables);
}
function* _zip(...iterables) {
    const length = iterables.length;
    const iterators = iterables.map(iterable => iterable[Symbol.iterator]());
    const dones = iterators.map(() => false);
    try {
        while (true) {
            const result = new Array(length);
            for (let i = 0; i < length; i++) {
                const { value, done } = iterators[i].next();
                if (done) {
                    dones[i] = true;
                    return;
                }
                result[i] = value;
            }
            yield result;
        }
    }
    finally {
        const undoneIterators = iterators.filter((_, i) => !dones[i]);
        undoneIterators.forEach(x => { var _a; return (_a = x.return) === null || _a === void 0 ? void 0 : _a.call(x); });
    }
}
//# sourceMappingURL=zip.js.map